import java.math.BigInteger;
import java.util.Arrays;

import AlZAGK.MatrixBigInt.MatrixBigInt;
import AlZAGK.VektorBigInt.VektorBigInt;
import AlZAGK.numbers.Rational.Rational;
import AlZAGK.numbers.Polynom.*;

/**
 * Eine mögliche Implementierung von Alg. 3.9 aus 
 * "Some Tapas of Computer Algebra", Kap 7.
 * @author Nils Przigoda
 * @version 0.1
 *
 */
public class Alg_3_9 {
	
	private static void o(Object o) {
		System.out.println(o);
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {		
		/* INPUT: 
		 * A \in N^{m x n}, c \in N^n
		 */
		o("Möchten Sie das IP selbst wählen, d.h. eine Matrix und eine Kostenfunktion" +
				" eingeben? - Drücken Sie Drücken Sie \"J\" für Ja:");
		String eingabe = "";
		Boolean input = false;
		try {		   
		   	eingabe = Input.readString();
	        if (eingabe.equals("J") || eingabe.equals("j") ||
	        		eingabe.equals("Ja") || eingabe.equals("ja") ||
	        		eingabe.equals("Y") || eingabe.equals("y") ||
	        		eingabe.equals("Yes") || eingabe.equals("yes") ||
	        		eingabe.equals("Y") || eingabe.equals("y")) {	        	
	        	input = true;	        	
	        } else {
	        	input = false;
	        }
	    } catch (NumberFormatException e) {
	        System.out.println("Bei Ihrer Eingabe \""+ eingabe +"\" ist ein" +
	        		" Fehler aufgetreten\n" +
	        		" Bitte nochmal eingeben:");
	        input = false;
	    }
	    MatrixBigInt A = new MatrixBigInt();
	    VektorBigInt c = new VektorBigInt();
	    if (!input) {
	    	/*
	    	 * Wähle ein fertiges Beispiel: 
	    	 */
	    	A = new MatrixBigInt
			(new BigInteger[][] 
			 {{new BigInteger("1"),new BigInteger("1"),
				 new BigInteger("1"),new BigInteger("1")},
			  {new BigInteger("0"),new BigInteger("1"),
				 new BigInteger("2"),new BigInteger("3")}});
	    	// c \in N^n
	    	c = new VektorBigInt(new BigInteger[] 
		     {new BigInteger("1"),new BigInteger("3"),
				 new BigInteger("14"),new BigInteger("17")});			 	
			
	    } else {
	    	/*
	    	 * Ansonsten IP eingeben:
	    	 */
	    	o("Bitte geben zunächst die Anzahl der Zeilen der Matrix A ein:");
	    	int zeilen = 0, spalten = 0;
	    	boolean nochmal  = false;
	    	do {
		    	try {		   
				   	eingabe = Input.readString();
			        zeilen = Integer.parseInt(eingabe);		        
			        o("Sie möchten eine Matrix mit " + zeilen + " Zeilen.");
			        nochmal = false;
			      } catch (NumberFormatException e) {
			        System.out.println("\""+ eingabe +"\" ist keine ganze Zahl\n" +
			        		" Bitte nochmal eingeben:");
			        
			      }	
	    	} while(nochmal);
	    	o("Bitte geben nun die Anzahl der Spalten der Matrix A ein:");
	    	nochmal  = false;
	    	do {
		    	try {		   
				   	eingabe = Input.readString();
			        spalten = Integer.parseInt(eingabe);		        
			        o("Sie möchten eine Matrix mit " + spalten + " Spalten.");
			        nochmal = false;
			      } catch (NumberFormatException e) {
			        System.out.println("\""+ eingabe +"\" ist keine ganze Zahl\n" +
			        		" Bitte nochmal eingeben:");
			        
			      }	
	    	} while(nochmal);
	    	
	    	o("Bitte geben Sie nun die positive ganzzahlige Matrix Zeilenweise ein:");
	    	BigInteger[][] A_tmp = new BigInteger[zeilen][spalten];	    	
	    	for (int i=0; i < zeilen; i++) {
	    		for (int j=0; j < spalten; j++) {
	    			System.out.print("a_{"+(i+1)+","+(j+1)+"}=");
	    			nochmal  = false;
	    			do {
	 				   try {		   
	 					   	eingabe = Input.readString();	 				        
	 				        A_tmp[i][j] =new BigInteger( 
	 				        		((Integer)(Integer.parseInt(eingabe))).toString() );
	 				        //o("a_{"+i+","+j+"}=" + A_tmp[i][j].toString());
	 				        nochmal = false;
	 				      } catch (NumberFormatException e) {
	 				        System.out.println("\""+ eingabe +"\" ist keine ganze Zahl\n" +
	 				        		" Bitte nochmal eingeben:");
	 				        nochmal = true;
	 				      }		
	 		
	 				} while (nochmal); 
	    		}
	    	}
	    	o("Bitte geben Sie nun den positiven ganzzahligen Vektor c ein:");	    	
	    	BigInteger[] c_tmp = new BigInteger[spalten];
	    	for (int i=0; i < spalten; i++) {	    	
    			System.out.print("c_{"+(i+1)+"}=");
    			nochmal  = false;
    			do {
 				   try {		   
 					   	eingabe = Input.readString();	 				        
 				        c_tmp[i] =new BigInteger( 
 				        		((Integer)(Integer.parseInt(eingabe))).toString() );
 				        //o("c_{"+i+"}=" + c_tmp[i].toString());
 				        nochmal = false;
 				      } catch (NumberFormatException e) {
 				        System.out.println("\""+ eingabe +"\" ist keine ganze Zahl\n" +
 				        		" Bitte nochmal eingeben:");
 				        nochmal = true;
 				      }		 		
 				} while (nochmal); 	    		
	    	}
	    	A = new MatrixBigInt(A_tmp);
	   	    c = new VektorBigInt(c_tmp);
	    }
	 
	    
	    /* Nun bestimme man ein "big-M" als BigInt-Konstante.
		 * Dafür schreibt ich zunächst die Zahl in 10er-Blöcken
		 * als String auf: 
		 */
		
		String temp = "1" + 
		"0000000000" + "0000000000" + "0000000000" + // 3
		"0000000000" + "0000000000" + "0000000000" + // 6
		"0000000000" + "0000000000" + "0000000000" + // 9
		"0000000000" + "0000000000" + "0000000000" + //12
		"0000000000" + "0000000000" + "0000000000" + //15
		"0000000000" + "0000000000" + "0000000000" + //18
		"0000000000" + "0000000000" + "0000000000" + //21
		"0000000000" + "0000000000" + "0000000000" + //24
		"0000000000" + "0000000000" + "0000000000" + //27
		"0000000000" + "0000000000" + "0000000000" + //30
		"0000000000" + "0000000000" + "0000000000" + //33
		"0000000000" + "0000000000" + "0000000000" + //36
		"0000000000" + "0000000000" + "0000000000" + //39
		"0000000000" + "0000000000" + "0000000000" + //42
		"0000000000" + "0000000000" + "0000000000";  //45
	
		// Die sehr große Konstante nun als BigInteger initialisieren: 	
		final BigInteger M = new BigInteger(temp);
		
		// Nun wird noch ein Vektor 
		BigInteger[] ones = BigIntegerOnes(A.Zeilen);	
		VektorBigInt M1c = new VektorBigInt(ones);
		// M1c.print();
		M1c = M1c.SkMult(M);
		M1c = M1c.Comb(M1c.vektor,c.vektor);
		M1c.print();	
		A.print();		
		
		// Jetzt bilde das Erzeugendensystem	
		Polynom[] erzeuger = new Polynom[A.Spalten];	
		for (int i=1; i <= A.Spalten; i++) {
			Rational[] coeff = new Rational[2];
			VektorBigInt[] binoms = new VektorBigInt[2];
			VektorBigInt e_i = new VektorBigInt(A.Spalten,i);
			VektorBigInt tmp_1 = new VektorBigInt(A.Spalten);
			VektorBigInt tmp_2 = A.MultSp(e_i);
			// Die beiden Monome des Binoms sind:
			binoms[0] = Comb(tmp_2.vektor, tmp_1.vektor);
			binoms[1] = Comb(new VektorBigInt(A.Zeilen).vektor, 
					new VektorBigInt(A.Spalten, i).vektor);
			// und die Koeffizienten davor lauten:
			coeff = new Rational[] {new Rational(1,1), new Rational(-1,1)};
			erzeuger[i-1] = new Polynom(binoms, coeff);	
		}
		
		// Testweise, die Ausgabe des Erzeugendensystems
		o("\n\n== ERZEUGER BEG ==\n");
		for (int i=0; i<erzeuger.length;i++) {
			erzeuger[i].print();
		} o("\n== ERZEUGER END ==\n\n");
		// Bilde Groebner-Basis
		Polynom[] gb_tmp = Polynom.GB(erzeuger, M1c);
		
		// Bilde nun die red. GB bei vorgegebener GB:
		gb_tmp = Polynom.redGB(gb_tmp, M1c);		
		/* Ausgabe unterdrücken
		o("\nListe jetzt die GB auf:");
		if (gb_tmp == null) {
			o("ist null");
		} else {
			for (int i=0; i<gb_tmp.length;i++)
				gb_tmp[i].print();
			}*/	
		
		VektorBigInt[] Test_Menge = new VektorBigInt[gb_tmp.length];
		for (int i=0; i < gb_tmp.length; i++) {		
			Test_Menge[i] = gb_tmp[i].KanBij();
		}
		o("Bitte geben Sie jetzt den " + A.Zeilen + "-zeiligen Ergebnis-Vektor b ein:");
		VektorBigInt b = new VektorBigInt(A.Zeilen); 
		for (int i=0; i < A.Zeilen; i++) {
			boolean nochmal  = false;
			/* Eingabe parsen
			 * b.vektor[i] = new BigInteger( EINGABE );
			 */
			eingabe = "";
			do {
			   try {		   
				   	eingabe = Input.readString();
			        int j = Integer.parseInt(eingabe);
			        b.vektor[i] = new BigInteger( ((Integer)(j)).toString() );
			        o("Der Eingebene Wert war: " + b.vektor[i].toString());
			        nochmal = false;
			      } catch (NumberFormatException e) {
			        System.out.println("\""+ eingabe +"\" ist keine ganze Zahl\n" +
			        		" Bitte nochmal eingeben:");
			        nochmal = true;
			      }		
	
			} while (nochmal); 
		} 
		VektorBigInt start = new VektorBigInt(A.Spalten+A.Zeilen);
		start = Comb(b,new VektorBigInt(A.Spalten));
		MatrixBigInt A_strich = CombMat(new MatrixBigInt(A.Zeilen),A);	
		Alg_3_5 Solve = new Alg_3_5(Test_Menge,A_strich,start,b,M1c);
		Solve.main();
		VektorBigInt optimale_loesung = Solve.Give_Opt();
		if (Feasible(optimale_loesung,A.Zeilen, A.Spalten)) { 
			optimale_loesung = Streiche(optimale_loesung, A.Zeilen, A.Spalten);
			o("Das Problem ist zulässig und die optimale Lösung lautet:");
			optimale_loesung.printZ();
		} else {
			// infeasible Problem
		}		
	}
	
	public static VektorBigInt Streiche(VektorBigInt vektor,int Zeilen, int Spalten) {
		VektorBigInt tmp = new VektorBigInt(Spalten);
		for (int i=0; i < Spalten; i++) {
			tmp.vektor[i]= vektor.vektor[i+Zeilen];							
		}
		return tmp;
	}
	
	public static boolean Feasible(VektorBigInt vektor,int Zeilen, int Spalten) {
		if (vektor == null) {
			o("FEHLER: Der Vektor ist null-Ref."); 
				return false;
			}
		if (vektor.length != Zeilen + Spalten) {
			o("FEHLER: Der Vektor hat nicht die gefordert Länge!"); 
			return false;
		}
		boolean a1_0 = true;
		for (int i=0; i < Zeilen; i++) {
			if (vektor.vektor[i].equals(new BigInteger("0"))) {
				// alles ok
			} else {
				o("Der " + i + "-te Eintrag von a_1 ist " + vektor.vektor[i].toString()
						+ " und nicht null, daher ist das Problem nicht zulässig!");
				a1_0 = false;				
			}
		}							
		return a1_0;
	}

	private static MatrixBigInt CombMat(MatrixBigInt A1,
			MatrixBigInt A2) {
		if (A1.Zeilen != A2.Zeilen) {
			o("Die Matrizen haben nicht gleich viele Zeilen!");
			return null;
		}
		
		BigInteger[][] m = new BigInteger[A1.Zeilen][A1.Spalten+A2.Spalten];
		for (int i=0; i < A1.Spalten; i++) {
			for (int j=0; j < A1.Zeilen; j++) {				
				m[j][i] = A1.Give_Element(i,j);
			}
		}
		for (int i=0; i < A2.Spalten; i++) {
			for (int j=0; j < A2.Zeilen; j++) {
				m[j][i+A1.Spalten] = A2.Give_Element(i,j);
			}
		}		
		return new MatrixBigInt(m);
	}

	public static VektorBigInt Comb(VektorBigInt x, VektorBigInt y) {		
		return Comb(x.vektor, y.vektor);
	}

	/**
	 * Erzeugt einen aus a1 und a2 zusammengesetzen Vektor der 
	 * Form (a1,a2) vom Typ VektorBigInt, wobei a1 und a2 allerdings
	 * BigInteger[] Arrays sind. 
	 * @param a1 Der erste Teil des neuen Vektors
	 * @param a2 Der zweite Teil des neuen Vektors
	 * @return Der zusammengesetze neue Vektor aus a1 und a2
	 */
	public static VektorBigInt Comb (BigInteger[] a1, BigInteger[] a2) {
    	BigInteger[] tmp = new BigInteger[a1.length+a2.length];    	
    	for (int i=0; i < tmp.length; i++)
    		if (i < a1.length) 
    			tmp[i] = a1[i];
    		else 
    			tmp[i] = a2[i-a1.length];    	
    	return new VektorBigInt(tmp);
    }

	/**
	 * Erzeugt ein Vektor mit BigInteger Einträgen, welche alle 1 sind
	 * und besteht aus Laenge-vielen Eintraegen 
	 * @param Laenge
	 * @return den erzeugten Vektor mit Sp
	 */
	private static BigInteger[] BigIntegerOnes(int Laenge) {
		BigInteger[] tmp = new BigInteger[Laenge];
		Arrays.fill(tmp, new BigInteger("1"));
		return tmp;
	}
	
}
