package AlZAGK.VektorBigInt;

import java.util.Arrays;
import java.math.BigInteger;

public class VektorBigInt {	
	//class VektorBigInt implements Comparable {
    public BigInteger[] vektor;   // Der Vektor c für die Term Order    
    public final int length;

    private static void o(Object o) {
		System.out.println(o);
	}

    public VektorBigInt() {
    	vektor = new BigInteger[0];
    	length = 0;
    }
    
    public VektorBigInt(BigInteger[] v) {
    	vektor = v.clone();
    	length = vektor.length;
    }
    
    public VektorBigInt(int dim, int i) {
    	//o(dim + "dim, i" + i);
    	vektor = new BigInteger[dim];
    	Arrays.fill(vektor, new BigInteger("0"));
    	vektor[i-1] = new BigInteger("1");
    	length = vektor.length;
    }
    
    /**
     * Erzeugt einen Nullvektor
     * @param i
     */
    public VektorBigInt(int i) {
    	vektor = new BigInteger[i];
    	Arrays.fill(vektor, new BigInteger("0"));    	
    	length = vektor.length;
    }
        
    public VektorBigInt Comb (BigInteger[] a1, BigInteger[] a2) {    	
    	BigInteger[] tmp = new BigInteger[a1.length+a2.length];    	
    	for (int i=0; i < tmp.length; i++)
    		if (i < a1.length) 
    			tmp[i] = a1[i];
    		else 
    			tmp[i] = a2[i-a1.length];    	
    	return new VektorBigInt(tmp);
    }
    
    public VektorBigInt SkMult(BigInteger Skalar) {
    	BigInteger[] temp = new BigInteger[length];
    	for (int i=0; i < length;i++) { 
    		temp[i] = vektor[i].multiply(Skalar);
    		o(temp[i].toString());
    	}
    	return new VektorBigInt(temp);
    }
    
    /**
     * Überprüft, ob 2 VektorBigInts gleich sind,
     * @param a
     * @return false wenn die Längen unterschiedlich sind
     * @return false falls sich 1 Eintrag unterscheidet und die Längen gleich sind 
     * @return true sonst
     */
    public boolean equals(VektorBigInt a) {
    	if (a.length != this.length)
    		return false;
    	for (int i=0; i < this.length;i++)     		
        	if (!a.vektor[i].equals(this.vektor[i]))
        			return false;        		        	
        return true;        
    }       
    
    /**
     * Gibt an ob der Vektor komponentenweise 
     * kleinergleich dem übergegebenen ist.
     * @param a
     * @return
     */
    public boolean smaleq(VektorBigInt a) {
    	if (a.length != this.length)
    		return false;
    	for (int i=0; i < this.length;i++)
        	if (this.vektor[i].compareTo(a.vektor[i]) < 0)
        			return false;
        return true;        
    }    
    
    public VektorBigInt Add(VektorBigInt b) {
    	if (this.length != b.length) {
    		System.out.println("Vektoren verschieden lang");
    		return (new VektorBigInt());
    	}    	
    	BigInteger[] temp = new BigInteger[this.length];
    	VektorBigInt tmp = new VektorBigInt(temp);    	
    	for (int i=0; i < this.length ; i++) {
    		tmp.vektor[i] = vektor[i].add(b.vektor[i]);    		
    	}
    	return tmp;
    }
    
    public VektorBigInt Sub(VektorBigInt b) {
    	if (this.length != b.length) {
    		System.out.println("Vektoren verschieden lang");
    		return (new VektorBigInt());
    	}
    	BigInteger[] temp = new BigInteger[this.length];
    	VektorBigInt tmp = new VektorBigInt (temp);    	
    	for (int i=0; i < this.length ; i++) {
    		tmp.vektor[i] = vektor[i].subtract(b.vektor[i]);    		
    	}
    	return tmp;
    }
          
    public BigInteger term_order_c (VektorBigInt c) {
    	if (this.length != c.length) {
    		System.out.println("Vektoren verschieden lang");
    		return new BigInteger("-1");
    	}
    	BigInteger a = new BigInteger("0");
    	for (int i=0; i < this.length ; i++) {
    		a = a.add((this.vektor[i].multiply(c.vektor[i])));    		
    	}
    	return a;
    }
    
    public void print () {
    	if (length == -1 ){
    		System.out.println("leerer Vektor");
    		return;
    	}
    	System.out.println();
    	for (int i=0; i < this.length ; i++) 
    		System.out.println( vektor[i].toString());     		    	
    	System.out.println();
    }
    
    public void printZ () {
    	if (length == -1 ){
    		System.out.println("leerer Vektor");
    		return;
    	}
    	System.out.println();
    	for (int i=0; i < this.length ; i++) 
    		System.out.print(" " + vektor[i].toString());     		    	
    	System.out.print("\n");
    }	
    
}